# mumble auth script via api sync
# written by arrai & bogie
# built on the default api.eveonline.com python script
# expects password from client: userid@apikey
# done:
#
# downloading + checking API for character data
# groups, acls
#
# todo:
#
# optimize download(threading?)
# ???
# profit
#
#
#Copyright (C) 2009 bogie,arrai
#
#This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License 
#as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
#or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.


import httplib, urllib
import xml.dom.minidom
import Ice, sys
import time
import os
import thread
import MySQLdb
from datetime import datetime
from scipy import *
Ice.loadSlice('Murmur.ice')
import Murmur

####
# config start
allowGuests = False
channelId = -1
# this is the id of your server
handled_server_id = 1
verbose="on"
id_offset = 1000000
fclist = []
adminlist = []
apiOnline = True

# mysql conf

dbname="eveauth"
dbuser="eveauth"
dbpass="asdfds"
dbhost="127.0.0.1"

# temp fclist

#fclist.append("Kythren")
adminlist.append("Kythren")
executor_charid = ""
executor_userid = ""
executor_apikey = ""
executor_corpid = ""
executor_allyname = ""

# config end
###
global curChanIds, curChanNames, channelexists
channelexists = False


def logOut(mes):
	if verbose == "on":
		print mes

def checklogin(userid,apikey):
	params = urllib.urlencode( {
    'characterID': 0,
    'userid': userid,
    'apikey': apikey,
    } )
	file = "/account/Characters.xml.aspx"
	headers = { "Content-type": "application/x-www-form-urlencoded" }
	conn = httplib.HTTPConnection("api.eve-online.com")
	conn.request("POST", file, params, headers)
	response = conn.getresponse()
	if response.status != 200:
		print response.status
		conn.close
		return -1
	else:
		data = response.read()
		xmlf = xml.dom.minidom.parseString(str(data))
		conn.close
		eapi = xmlf.getElementsByTagName('eveapi')[0]
		for node in eapi.childNodes:
			if node.nodeName == "error":
				return int(eapi.getElementsByTagName('error')[0].attributes['code'].value)
		print "i return -2"
		return -2

def getXMLfromAPI(file,charid,userid,apikey):
	params = urllib.urlencode( {
	'characterID': charid,
	'userid': userid,
	'apikey': apikey,
	} )
	headers = { "Content-type": "application/x-www-form-urlencoded" }
	conn = httplib.HTTPConnection("api.eve-online.com")
	conn.request("POST", file, params, headers)
	response = conn.getresponse()
	if response.status != 200:
		print response.status
		conn.close
		return -1
	else:
		data = response.read()
		xmlf = xml.dom.minidom.parseString(str(data))
		conn.close
		return xmlf
	return -1

def saveXMLfromAPI(file,charid,userid,apikey):
	params = urllib.urlencode( {
	'characterID': charid,
	'userid': userid,
	'apikey': apikey,
	} )
	headers = { "Content-type": "application/x-www-form-urlencoded" }
	conn = httplib.HTTPConnection("api.eve-online.com")
	conn.request("POST", file, params, headers)
	response = conn.getresponse()
	if response.status != 200:
			print response.status
			conn.close
			return -1
	else:
			data = response.read()

	temp = file.split("/")
	filename = ""
	filename += str(userid)
	filename += "-"
	filename += str(charid)
	filename += "-"
	filename += temp[1]
	filename += "-"
	filename += temp[2]

	f = open(filename,'w')
	f.write(data)
	conn.close
	return 1

def checkCacheTime(file):
	if os.path.isfile(file):
		xmlf = xml.dom.minidom.parse(file)
		expiretime = xmlf.getElementsByTagName('eveapi')[0].getElementsByTagName('cachedUntil')[0].childNodes[0].nodeValue
		dtup = datetime.strptime(expiretime,"%Y-%m-%d %H:%M:%S")
		tstamp = time.mktime(dtup.timetuple())
		if time.time() >= tstamp:
			return 1
		else:
			return 0
	else:
		return -1

def getXMLs():
	global chartocorp,charsheetxml,chartoally,charlistxml,corpsheetxml,exec_standxml,eve_alliancesxml,server_statusxml

	#if not(os.path.isfile("eve-AllianceList.xml.aspx")):
	#	saveXMLfromAPI("/eve/AllianceList.xml.aspx",0,0,0)
	#	eve_alliancesxml = xml.dom.minidom.parse("eve-AllianceList.xml.aspx")
	cacheStatus = checkCacheTime(str(userid)+"-0-account-Characters.xml.aspx")
	if cacheStatus == 1:
		logOut("fetching new account-Characters.xml.aspx")
		saveXMLfromAPI("/account/Characters.xml.aspx",0,userid,apikey)
	elif cacheStatus == -1:
		logOut("file characters.xml not found")
		saveXMLfromAPI("/account/Characters.xml.aspx",0,userid,apikey)
	else:
		logOut("characters.xml up to date")

	charlistxml = xml.dom.minidom.parse(str(userid)+"-0-account-Characters.xml.aspx")
	charidlist = []
	chars = []
	corps = []
	for row in charlistxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('rowset')[0].getElementsByTagName('row'):
		chars.append(int(row.attributes['characterID'].value))
		corps.append(int(row.attributes['corporationID'].value))
		charidlist.append(int(row.attributes['characterID'].value))
	chartocorp = mat([chars,corps])

	allies = []

	for charid in chars:
		if checkCacheTime(str(userid)+"-"+str(charid)+"-corp-CorporationSheet.xml.aspx") != 0: 
			saveXMLfromAPI("/corp/CorporationSheet.xml.aspx",charid,userid,apikey)
		corpsheetxml = xml.dom.minidom.parse((str(userid)+"-"+str(charid)+"-corp-CorporationSheet.xml.aspx"))
		allies.append(int(corpsheetxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('allianceID')[0].childNodes[0].nodeValue))

	chartoally = mat([chars,allies])

	cacheStatus = checkCacheTime(str(executor_userid)+"-"+str(executor_charid)+"-corp-Standings.xml.aspx")
	if cacheStatus == 1:
		#os.remove('corp-Standings.xml.aspx')
		logOut("Notice: fetching new corp-Standings.xml.aspx")
		saveXMLfromAPI("/corp/Standings.xml.aspx",executor_charid,executor_userid,executor_apikey)
	elif cacheStatus == 0:
		logOut("Notice: corp-Standings.xml.aspx is up to date")
	elif cacheStatus == -1:
		logOut("executor Standings not found, fetching new")
		saveXMLfromAPI("/corp/Standings.xml.aspx",executor_charid,executor_userid,executor_apikey)
	exec_standxml = xml.dom.minidom.parse(str(executor_userid)+"-"+str(executor_charid)+"-corp-Standings.xml.aspx")

def isInCorpWithExecutor():
	for i in range(0,size(chartocorp[0,:])):
		corpid = chartocorp[1,i]
		logOut(corpid)
		if int(corpid) == int(executor_corpid):
			return chartocorp[0,i]
	return -1

def getCharName(charid):
	rowset = charlistxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('rowset')[0]
	for rows in rowset.getElementsByTagName('row'):
		if int(rows.attributes["characterID"].value) == charid:
			return rows.attributes["name"].value

def getAllyName(charid):
	 corpsheetxml = xml.dom.minidom.parse(str(userid)+"-"+str(charid)+"-corp-CorporationSheet.xml.aspx")
	 allyname = corpsheetxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('allianceName')[0].childNodes[0].nodeValue
	 return allyname

def getCorpName(charid):
	rowset = charlistxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('rowset')[0]
	for rows in rowset.getElementsByTagName('row'):
		if int(rows.attributes["characterID"].value) == charid:
			return rows.attributes["corporationName"].value

def getCorpTicker(charid):
	corpsxml = xml.dom.minidom.parse(str(userid)+"-"+str(charid)+"-corp-CorporationSheet.xml.aspx")
	tickername = corpsxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('ticker')[0].childNodes[0].nodeValue
	return tickername

def isDirector(charid,userid,apikey):
	if apiOnline == False:
		return -1
	saveXMLfromAPI("/char/CharacterSheet.xml.aspx",charid,userid,apikey)
	charsheetxml = xml.dom.minidom.parse(str(userid)+"-"+str(charid)+"-char-CharacterSheet.xml.aspx")
	rowset = charsheetxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0]
	for rows in rowset.getElementsByTagName('rowset'):
		if rows.attributes["name"] == "corporationRoles":
			for row in rows.getElementsByTagName('row'):
				if row.attributes["roleName"] == "roleDirector":
					return 1
	return 0

def printTitles(server,session,charid,userid):
	charsheetxml = xml.dom.minidom.parse(str(userid)+"-"+str(charid)+"-char-CharacterSheet.xml.aspx")
	rowset = charsheetxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0]
	for rows in rowset.getElementsByTagName('rowset'):
		if rows.attributes["name"] == "corporationTitles":
			for row in rows.getElementsByTagName('row'):
				server.sendMessage(session,row.attributes)

def existsCorpChannel(name):
	print curCorpChannels
	for idx in range(0,size(curCorpChannels[0,:])):
		if curCorpChannels[1,idx] == name:
			return True
	return False

def instantExistsCorpChannel(name,server,charid):
	channels2 = server.getChannels()
	for channel in channels2:
		if channels2[channel].name == str(name):
			return
	createCorpChannel(name, server, charid)

def createCorpChannel(channelName, server, playerid):
	print 'creating corp channel '+channelName
	time.sleep(2)
	newChannelId = server.addChannel(channelName, corpChanId)
	curChanIds.append(newChannelId)
	curChanNames.append(str(channelName))
	curCorpChannels = mat( [curChanIds,curChanNames] )
	acl = server.getACL(newChannelId)
	newAclEntry = Murmur.ACL()
	newAclEntry.applyHere = True
	newAclEntry.applySubs = True
	newAclEntry.inherited = True
	newAclEntry.group = getCorpName(playerid)
	newAclEntry.allow = 1
	newAclEntry.deny = 0
	acl[0].append(newAclEntry)
	server.setACL(newChannelId, acl[0], acl[1], acl[2])
	print 'chan created'
	return 1

def addUsers(server, charid, groupname):
	found = 0
	i = 0
	acl = server.getACL(0)
	gacl = acl[1]
	for ga in gacl:
		if ga.name == groupname:
			found = i
		i += 1
	if found == 0:
		group = Murmur.Group()
		group.name = groupname
		group.inheritable = True
		group.inherit = True
		group.inherited = False
		group.add = [charid]
		gacl.append(group)
	else:
		gacl = acl[1]
		if not(charid in gacl[found].members):
			print "nono"
			gacl[found].members.append(charid)
			gacl[found].add.append(charid)
			print gacl[found].members
			print gacl[found].add
	server.setACL(0, acl[0], gacl, acl[2])

def checkAllianceStandingsByCharList():
	signals = -1
	enemy = 0
	if not(exec_standxml):
		return -1
	typelist = exec_standxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('allianceStandings')[0].getElementsByTagName('standingsTo')[0]
	for rowset in typelist.getElementsByTagName('rowset'):
		if rowset.attributes["name"].value != "alliances":
			continue
		for row in rowset.getElementsByTagName('row'):
			for i in range(0,size(chartoally[0,:])):
				if verbose == "on":
					logOut("checking allyid in allylist")
					logOut(chartoally[1,i])
				if int(row.attributes["toID"].value) == chartoally[1,i]:
					if float(row.attributes["standing"].value) > 0:
						signals = chartoally[0,i]
					elif float(row.attributes["standing"].value) <= 0:
						enemy = 1
	if enemy == 0:
		return signals
	elif enemy == 1:
		return -2

def checkCorporationStandingsByCharList():
	signals = -1
	enemy = 0
	typelist = exec_standxml.getElementsByTagName('eveapi')[0].getElementsByTagName('result')[0].getElementsByTagName('corporationStandings')[0].getElementsByTagName('standingsTo')[0]
	for rowset in typelist.getElementsByTagName('rowset'):
		if rowset.attributes["name"].value == "corporations":
			for row in rowset.getElementsByTagName('row'):
				for i in range(0,size(chartocorp[0,:])):
					if verbose == "on":
						print 'checking corpid in corplist ',chartocorp[1,i],'xml data: ',int(row.attributes["toID"].value)
					if int(row.attributes["toID"].value) != chartocorp[1,i]:
						continue
					if float(row.attributes["standing"].value) > 0:
						signals = chartocorp[0,i]
					elif float(row.attributes["standing"].value) < 0:
						enemy = 1
	if enemy == 0:
		return signals
	else:
		return -2

def checkStandings():
	charid = int(isInCorpWithExecutor())
	if charid > 0:
		print 'char is in same corp as executor'
		return charid

	charid = int(checkAllianceStandingsByCharList())
	if charid > 0:
		#authenticate
		print 'auth!'
		return charid
		#authenticate(charid)
	elif charid == -2:
		print 'ENEMY SPIES'
		return -1
	elif charid == -1:
		charid = int(checkCorporationStandingsByCharList())
		if charid > 0:
			#authenticate
			print 'auth!'
			return charid
			#authenticate(charid)
		elif charid == -1:
			#fail no auth!
			print 'fail no auth!'
			return 0
		elif charid == -2:
			print 'ENEMY SPIES'
			return -1

def getGroupList(charid):
	groups = []
	c.execute("SELECT groupname FROM groups WHERE charid = %s",charid)
	for rows in c.fetchall():
		groups.append(rows[0])
	return groups

#print checkStandings()

###
# mumble auth part
###

def useridExistsInDb(userid):
	c.execute("SELECT userid FROM users WHERE userid = %s",int(userid))
	rows = c.fetchall()
	if(len(rows)==0):
		return 0
	else:
		return 1

class ServerAuthenticatorI(Murmur.ServerUpdatingAuthenticator):
	global server
	def __init__(self, server, adapter):
		self.server = server

	def authenticate(self, name, pw, certificates, certhash, cerstrong, out_newname):
		global id_offset, guest_offset, userid, apikey,db,c
		start = time.time()
		apistatus = 0
		apiOnline = True
		userid = None
		apikey = None
		charid = 0
		corpId = 0
		corpTicker = ""
		corpName = ""
		allyId = 0
		allyTicker = ""
		allyName = ""
		groups = []
		isFc = 0
		db = MySQLdb.connect(dbhost,dbuser,dbpass,dbname)
		c = db.cursor()
		templist = pw.split("@")
		if len(templist) > 1:
			userid = templist[0]
			apikey = templist[1]
		else:
			 print 'no @ ?'
			 return (-1, None, None)
		if(userid == None or len(userid) == 0):
			return (-1, None, None)
		if(apikey == None or len(apikey) == 0):
			return (-1, None, None)
		userstatus = checklogin(userid,apikey)
		print "userstatus is "+str(userstatus)
		userstatus = int(userstatus)
		if userstatus == -2:
			apiOnline = True
		if userstatus == 211:
			apiOnline = True
			print "account has no active subscription"
			return (-1, None, None)
		if userstatus == 106:
			apiOnline = True
			print "sorry but wtf?"
			return (-1, None, None)
		if userstatus == 902:
			print "api is down"
			apiOnline = False
		
		## check config executor api key
		execstatus = int(checklogin(executor_userid, executor_apikey))
		if execstatus == -2:
			apiOnline = True
		if userstatus == 211:
			apiOnline = True
			print "account has no active subscription"
			return (-1, None, None)
		if userstatus == 106:
			apiOnline = True
			print "you have supplied a not working api key for executor char"	
			return (-1, None, None)
		if userstatus == 902:
			print "api is down"
			apiOnline = False

		if apiOnline == False:
			alias = name
			c.execute("SELECT userid FROM users WHERE charname =%s",alias)
			m_userid = c.fetchone()
			if m_userid == None:
				print "mysql auth - unkown username "+alias
				return (-1, None, None)
			if int(m_userid[0]) == int(userid):
				c.execute("SELECT userid,charid,corpid,corpticker,corpname,allyid,allyticker,allyname,isfc FROM users WHERE charname =%s",alias)
				for row in c.fetchall():
					userid = int(row[0])
					charid = int(row[1])
					corpId = int(row[2])
					corpTicker = row[3]
					corpName = row[4]
					allyId = int(row[5])
					allyTicker = row[6]
					allyName = row[7]
					isfc = int(row[8])
				print "mysql auth - successfull for user "+alias
			elif m_userid[0] != userid:
				print "mysql auth - failed for user "+alias
		else:
			getXMLs()
			charid = checkStandings()
			if charid == 0:
				return(-1, None, None)
			alias = getCharName(charid)
			allyName = getAllyName(charid)
			corpName = getCorpName(charid)
			corpTicker = getCorpTicker(charid)
			corpId = 0
			allyId = 0
			isFc = 0
			for i in range(0,size(chartocorp[1,:])):
				if chartocorp[0,i] == charid:
					corpId = chartocorp[1,i]
			for i in range(0,size(chartoally[1,:])):
				if chartoally[0,i] == charid:
					allyId = chartoally[1,i]
			if(useridExistsInDb(userid) == 0):
				qry = "INSERT INTO `users` (`userid`,`charid`,`charname`,`corpid`,`corpticker`,`corpname`,`allyid`,`allyticker`,`allyname`,`isfc`) VALUES ('"+str(userid)+"','"+str(charid)+"','"+alias+"','"+str(corpId)+"','"+corpTicker+"','"+corpName+"','"+str(allyId)+"','tbd','"+allyName+"','"+str(isFc)+"')"
				c.execute(qry)
				qry = "INSERT INTO `groups`(`userid`,`charid`,`groupname`) VALUES ('"+str(userid)+"','"+str(charid)+"','"+corpName.lower()+"')"
				c.execute(qry)
				qry = "INSERT INTO `groups`(`userid`,`charid`,`groupname`) VALUES ('"+str(userid)+"','"+str(charid)+"','"+allyName.lower()+"')"
				c.execute(qry)
			else:
				qry = "DELETE FROM `groups` WHERE `userid` = '"+str(userid)+"'"
				c.execute(qry)
				qry = "INSERT INTO `groups`(`userid`,`charid`,`groupname`) VALUES ('"+str(userid)+"','"+str(charid)+"','"+corpName.lower()+"')"
				c.execute(qry)
				qry = "INSERT INTO `groups`(`userid`,`charid`,`groupname`) VALUES ('"+str(userid)+"','"+str(charid)+"','"+allyName.lower()+"')"
				c.execute(qry)
				isFc = c.execute("SELECT isfc FROM `users` WHERE `userid` = %s", str(userid))
				if isFc == 1:
					c.execute("INSERT INTO `groups`(`userid`,`charid`,`groupname`) VALUES ('"+str(userid)+"','"+str(charid)+"','fcs')")
				qry = "UPDATE `users` SET `corpid` = '"+str(corpId)+"', `corpticker` = '"+corpTicker+"', `corpname` = '"+corpName+"', `allyid` = '"+str(allyId)+"', `allyname` = '"+allyName+"', `allyticker` = '"+allyTicker+"' WHERE `userid`= '"+str(userid)+"'"
				c.execute(qry)

		# create corpchannels, in case they dont exist yet!
		if allyName == executor_allyname:
			thread.start_new_thread(instantExistsCorpChannel, (corpName, server, charid))
		if charid == -2:
			print "user %s is an enemy do not auth"%name
			return (-1, None, None)
		elif charid == 0:
			print "user %s is unkown, denying access"%name
			return (-1, None, None)
		else:
			groups = getGroupList(charid)
			prefix = allyName
			prefix += " | "
			prefix += corpTicker
			prefix += " | "

			for admins in adminlist:
				if admins == alias:
					groups.append("admin")
					thread.start_new_thread(addUsers, (server, charid, "admin"))
			thread.start_new_thread(addUsers, (server, charid, corpName.lower()))
			thread.start_new_thread(addUsers, (server, charid, allyName.lower()))
			if isFc == 1:
				thread.start_new_thread(addUsers, (server, charid, "fcs"))
			if apiOnline == True:
				if isDirector(charid,userid,apikey) == 1:
					thread.start_new_thread(addUsers, (server, charid, "director"))
				elif isDirector(charid,userid,apikey) == -1:
					print "authenticate - tried to add user to director group but api is offline, try again later"
			print int(time.time() - start)
			print groups
			c.close()
			#thread.start_new_thread(printTitles, (server, charid, charid, userid))
			return (charid, prefix+alias, groups)

	def createChannel(name, server, id):
		return -2
	def registerPlayer(self, name, current=None):
	  print "Someone tried to register " + name
	  return -1

	def idToTexture(self, id, current=None):
		return None

	def idToName(self, id, current=None):
		db = MySQLdb.connect(dbhost,dbuser,dbpass,dbname)
		c = db.cursor()
		c.execute("SELECT charname FROM users WHERE charid = %s",id)
		c.close()
		return None

	def nameToId(self, name, current=None):
		db = MySQLdb.connect(dbhost,dbuser,dbpass,dbname)
		c = db.cursor()
		c.execute("SELECT userid FROM users WHERE charname = %s",name)
		id = 0
		for rows in c.fetchall():
			id = rows[0]
		print id
		c.close()
		return id

	def unregisterPlayer(self, id, current=None):
	  return -1

	def getRegistration(self, id, current=None):
	  return (-2, None, None)

	def getInfo(self, id, current = None):
		return (False, None)

	def setInfo(self, id, info, current = None):
		return -1

	def setTexture(self, id, texture, current = None):
		return -1
	def registerUser(self, name, current = None):
		return -1
	def unregisterUser(self, name, current = None):
		return -1
	def getRegisteredUsers(self, filter, current=None):
		return dict()

if __name__ == "__main__":
    print "Creating callbacks..."
    ice = Ice.initialize(sys.argv)

    meta = Murmur.MetaPrx.checkedCast(ice.stringToProxy('Meta:tcp -h 127.0.0.1 -p 6502'))

    adapter = ice.createObjectAdapterWithEndpoints("Callback.Client", "tcp -h 127.0.0.1")
    adapter.activate()
	
    for server in meta.getBootedServers():
		if(server.id()!=handled_server_id):
			continue
		channels = server.getChannels()
		curChanIds = []
		curChanNames = []
		for channel in channels:
			curChanIds.append(channels[channel].id)
			curChanNames.append(channels[channel].name)
			if channels[channel].name == executor_allyname:
				corpChanId = channels[channel].id
		curCorpChannels = mat( [curChanIds,curChanNames] )
		print curCorpChannels
		print "binding to server:"
		print server
		print "id:", server.id()
		serverR=Murmur.ServerUpdatingAuthenticatorPrx.uncheckedCast(adapter.addWithUUID(ServerAuthenticatorI(server, adapter)))
		server.setAuthenticator(serverR)
		break

    print 'Script running (press CTRL-C to abort)';
    try:
        ice.waitForShutdown()
    except KeyboardInterrupt:
        print 'CTRL-C caught, aborting'

    ice.shutdown()
    print "Goodbye"


# setup the parameters we will be sending to the webserver; note that all of this
# information is gathered from the API Key page that the user should visit, and
# the characterID is gathered from /account/Characters.xml.aspx

